#include <iostream.h>

inline int other (int a, int b) { return 6-a-b; }

/**Solves the Towers of Hanoi problem, moving a stack
of rings from a stick to another one.
\arg ring: Number of rings (size of the problem)
\arg src: source stick (1,2 or 3)
\arg dst: destination stick (1,2 or 3)*/
void hanoi (int rings, int src, int dst)
{
	if (rings<1) return; //then there is no move to be done
	//move the N-1 rings above the biggest one to the "other" stick
	hanoi(rings-1,src,other(src,dst));
	//move the biggest ring from the source to the destination stick
	cout << src << " " << dst << endl;
	//move the rest N-1 rings from the "other" to the destination stick
	hanoi(rings-1,other(src,dst),dst);
}

int main()
{
	int rings;
	cout << "Welcome to the Towers of Hanoi\n";
	do { //read the input
		cout << "How many rings do you have?";
		cin >> rings;
		cout << endl;
	} while (rings<1 || rings>10);
	hanoi(rings,1,3); //begin solution
	return 0;
}
